Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Makefile.am	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -39,4 +39,5 @@
 	Parameters/Validators/GenericValidators.hpp \
 	Parameters/Validators/GenericValidators_impl.hpp \
+	Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp \
 	Parameters/Validators/Ops_Validator.hpp \
 	Parameters/Validators/Ops_Validator_impl.hpp \
Index: src/Parameters/Validators/Ops_Validator_impl.hpp
===================================================================
--- src/Parameters/Validators/Ops_Validator_impl.hpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Validators/Ops_Validator_impl.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -52,4 +52,6 @@
   Validator<T> *getA(){ return a; }
   Validator<T> *getB(){ return b; }
+  const Validator<T> *getA() const { return a; }
+  const Validator<T> *getB() const { return b; }
 
 private:
@@ -90,4 +92,9 @@
   }
 
+  Validator<T> *getA(){ return a; }
+  Validator<T> *getB(){ return b; }
+  const Validator<T> *getA() const { return a; }
+  const Validator<T> *getB() const { return b; }
+
 private:
   Validator<T> *a;
@@ -126,4 +133,7 @@
   }
 
+  Validator<T> *getA(){ return a; }
+  const Validator<T> *getA() const { return a; }
+
 private:
   Validator<T> *a;
Index: src/Parameters/Validators/Specific/FileSuffixValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/FileSuffixValidator.hpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Validators/Specific/FileSuffixValidator.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -33,4 +33,7 @@
   Validator< boost::filesystem::path >* clone() const;
 
+  const std::string & getSuffix() const
+  { return suffix; }
+
 private:
   std::string suffix;
Index: src/Parameters/Validators/Specific/ParserFileValidator.cpp
===================================================================
--- src/Parameters/Validators/Specific/ParserFileValidator.cpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Validators/Specific/ParserFileValidator.cpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -72,5 +72,13 @@
 }
 
+std::vector<std::string> ParserFileValidator::getSuffixes() const
+{
+  std::vector<std::string> suffixes;
+  for (ParserTypes t = ParserTypes_begin; t < ParserTypes_end; ++ t){
+    suffixes.push_back(
+        FormatParserStorage::getInstance().getSuffixFromType(t));
+  }
+  return suffixes;
+}
 
 
-
Index: src/Parameters/Validators/Specific/ParserFileValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/ParserFileValidator.hpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Validators/Specific/ParserFileValidator.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -27,4 +27,7 @@
   bool operator==(const Validator<boost::filesystem::path> &_instance) const;
   Validator< boost::filesystem::path >* clone() const;
+
+public:
+  std::vector<std::string> getSuffixes() const;
 };
 
Index: src/Parameters/Validators/Validator.hpp
===================================================================
--- src/Parameters/Validators/Validator.hpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/Parameters/Validators/Validator.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -35,4 +35,3 @@
 };
 
-
 #endif /* VALIDATOR_HPP_ */
Index: src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp
===================================================================
--- src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
+++ src/Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -0,0 +1,59 @@
+/*
+ * getFlatListFromHierarchyOfValidators.hpp
+ *
+ *  Created on: Sep 7, 2014
+ *      Author: heber
+ */
+
+#ifndef GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_
+#define GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <algorithm>
+#include <vector>
+
+#include "Parameters/Validators/Validator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+
+template <class T>
+void ValidatorHierarchyClimber(
+    const Validator<T> &_validator,
+    std::vector<std::pair<const Validator<T> *, bool> > &_validators,
+    const bool _groundtruth)
+{
+  if (dynamic_cast<const And_Validator<T> *>(&_validator) != NULL) {
+    const And_Validator<T>& and_validator = dynamic_cast<const And_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*and_validator.getA(), _validators, _groundtruth);
+    ValidatorHierarchyClimber(*and_validator.getB(), _validators, _groundtruth);
+  } else if (dynamic_cast<const Or_Validator<T> *>(&_validator) != NULL) {
+    const Or_Validator<T>& or_validator = dynamic_cast<const Or_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*or_validator.getA(), _validators, _groundtruth);
+    ValidatorHierarchyClimber(*or_validator.getB(), _validators, _groundtruth);
+  } else if (dynamic_cast<const Not_Validator<T> *>(&_validator) != NULL) {
+    const Not_Validator<T>& not_validator = dynamic_cast<const Not_Validator<T>& >(_validator);
+    ValidatorHierarchyClimber(*not_validator.getA(), _validators, !_groundtruth);
+  } else if (dynamic_cast<const Validator<T> *>(&_validator) != NULL) {
+    const Validator<T> * Tvalidator = dynamic_cast<const Validator<T> * >(&_validator);
+    _validators.push_back( std::make_pair(Tvalidator, _groundtruth) );
+  }
+}
+
+/** Function that recursively climbs down the hierarchy of validators and adds all
+ * to a common vector as tuples of validator and a boolean, giving the ground truth
+ * of the validator, i.e. whether it was negated by a prior Not_Validator.
+ */
+template <class T>
+std::vector<std::pair<const Validator<T> *, bool> >
+getFlatListFromHierarchyOfValidators(const Validator<T> &_validator)
+{
+  std::vector<std::pair<const Validator<T> *, bool> > validators;
+  ValidatorHierarchyClimber(_validator, validators, true);
+  return validators;
+}
+
+
+#endif /* GETFLATLISTFROMHIERARCHYOFVALIDATORS_HPP_ */
Index: src/UIElements/Qt4/Query/FileQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/FileQtQuery.cpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/UIElements/Qt4/Query/FileQtQuery.cpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -45,4 +45,12 @@
 #include "UIElements/Qt4/Query/QtQuery.hpp"
 
+#include <algorithm>
+#include <boost/filesystem.hpp>
+
+#include "Parameters/Validators/getFlatListFromHierarchyOfValidators.hpp"
+#include "Parameters/Validators/Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/FileSuffixValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
 #include "Parser/ParserTypes.hpp"
 #include "Parser/FormatParserStorage.hpp"
@@ -51,5 +59,6 @@
     QtQuery<boost::filesystem::path>(_param, _title, _description),
     parent(_parent),
-    dialog(_dialog)
+    dialog(_dialog),
+    mustBePresent(false)
 {
   filenameLineEdit = new QLineEdit();
@@ -71,4 +80,25 @@
 
   QObject::connect(filedialogButton,SIGNAL(clicked()),this,SLOT(showFileDialog()));
+
+  // fill list of suffixes
+  const Validator<boost::filesystem::path> &validator =
+      _param.getValidator();
+  typedef std::vector<std::pair<const Validator<boost::filesystem::path> *, bool> > validators_t;
+  const validators_t validators =
+      getFlatListFromHierarchyOfValidators<boost::filesystem::path>(validator);
+  for (validators_t::const_iterator iter = validators.begin();
+      iter != validators.end(); ++iter) {
+    const Validator< boost::filesystem::path > &currentvalidator = *iter->first;
+    if (dynamic_cast<const FileSuffixValidator * const>(&currentvalidator) != NULL)
+      suffixes.push_back(dynamic_cast<const FileSuffixValidator &>(currentvalidator).getSuffix());
+    if (dynamic_cast<const ParserFileValidator * const>(&currentvalidator) != NULL) {
+      const std::vector<std::string> moresuffixes =
+          dynamic_cast<const ParserFileValidator &>(currentvalidator).getSuffixes();
+      suffixes.insert(suffixes.end(), moresuffixes.begin(), moresuffixes.end());
+    }
+    if (dynamic_cast<const FilePresentValidator * const>(&currentvalidator) != NULL)
+      mustBePresent = iter->second;
+  }
+  std::sort(suffixes.begin(), suffixes.end());
 }
 
@@ -93,15 +123,13 @@
     // gather all possible suffixes
     QStringList filters;
-    std::stringstream parsersuffixes;
-    parsersuffixes << std::string("Config files (");
-    for (ParserTypes t = ParserTypes_begin; t < ParserTypes_end; ++t){
-      if (t != ParserTypes_begin)
-        parsersuffixes << std::string(" ");
-      parsersuffixes << std::string("*.") <<
-          FormatParserStorage::getInstance().getSuffixFromType(t);
+    std::stringstream filter_string;
+    if (!suffixes.empty()) {
+      filter_string << "Valid files (";
+      for (std::vector<std::string>::const_iterator iter = suffixes.begin();
+          iter != suffixes.end(); ++iter)
+        filter_string << (iter == suffixes.begin() ? "*." : " *.") << *iter << " ";
+      filter_string << ")";
+      filters << tr(filter_string.str().c_str());
     }
-    parsersuffixes << std::string(")");
-    filters << tr(parsersuffixes.str().c_str());
-    filters << tr("Data files (*.dat)");
     filters << tr("Any files (*)");
     theFileDialog->setNameFilters(filters);
Index: src/UIElements/Qt4/Query/QtQuery.hpp
===================================================================
--- src/UIElements/Qt4/Query/QtQuery.hpp	(revision ce4126dccd4487e1bb02f6582b75fc09fdf73408)
+++ src/UIElements/Qt4/Query/QtQuery.hpp	(revision dae15830575cff1e67648579393887f666f06f35)
@@ -211,4 +211,6 @@
   QFileDialog *theFileDialog;
   Dialog *dialog;
+  std::vector<std::string> suffixes;
+  bool mustBePresent;
 };
 
